
/**
 * Lucy Cabezas IT 215
 * August 1, 2013
 
 *
 */
// ProductTest4.java
import java.text.DecimalFormat;
import javax.swing.*;
import java.awt.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;

public class ProductTest4 extends JApplet {

    private static final long serialVersionUID = 1L;
    private JLabel logo = new JLabel(new ImageIcon("metal.jpg"));
    private JLabel itemNum = new JLabel("Item Number");
    private JTextField itemNumValue = new JTextField();
    private JLabel name = new JLabel("Name");
    private JTextField nameValue = new JTextField();
    private JLabel unit = new JLabel("Unit");
    private JTextField unitValue = new JTextField();
    private JLabel price = new JLabel("Price");
    private JTextField priceValue = new JTextField();
    private JLabel restockingFee = new JLabel("Restocking Fee");
    private JTextField rfValue = new JTextField();
    private JLabel invent = new JLabel("Inventory Value");
    private JTextField inventValue = new JTextField();
    private JLabel totalValue = new JLabel();
    private JButton first = new JButton("First");
    private JButton previous = new JButton("Previous");
    private JButton next = new JButton("Next");
    private JButton last = new JButton("Last");
    private ArrayList<Product> products = new ArrayList<Product>();
    private int current = 0;

    class ButtonListener implements ActionListener {

        public void actionPerformed(ActionEvent e) {
            JButton button = (JButton) e.getSource();
            int total = products.size();
            if (button == first) {
                current = 0;
            }
            if (button == previous) {
                current = (current + total - 1) % total;
            }
            if (button == next) {
                current = (current + 1) % total;
            }
            if (button == last) {
                current = total - 1;
            }
            display();
        }
    }

    private void display() {
        Product product = products.get(current);
        DecimalFormat df = new DecimalFormat("$#.00");
        itemNumValue.setText(product.getItemNum() + "");
        itemNumValue.setEditable(false);
        nameValue.setText(product.getItemName());
        nameValue.setEditable(false);
        unitValue.setText(product.getUnits() + "");
        unitValue.setEditable(false);
        priceValue.setText(df.format(product.getPrice()));
        priceValue.setEditable(false);
        rfValue.setText(df.format(product.getRestockingFee()));
        rfValue.setEditable(false);
        inventValue.setText(df.format(product.getInventoryValue()));
        inventValue.setEditable(false);
        totalValue.setText("The total inventory value is " + df.format(calculateAll()));
    }

    private double calculateAll() {
        // calculates all inventory values
        double value = 0.0;
        for (int i = 0; i < products.size(); i++) {
            value = value + products.get(i).getInventoryValue();
        }
        ProductDetail.setTotalInventoryValue(value);
        return ProductDetail.getTotalInventoryValue();
    }

    public void init() {

        products.add(new ProductDetail(100, "Slayer- Soundtrack to the Apocalypse", 30, 20.00));
        products.add(new ProductDetail(200, "Nirvana- The Boxed Set", 32, 50.00));
        products.add(new ProductDetail(300, "Metallica- Kill 'Em All", 17, 1.10));
        products.add(new ProductDetail(400, "Various Artists- Songs to rock out", 25, 66.66));

        // inventory shown in text area
        ButtonListener buttonListener = new ButtonListener();
        first.addActionListener(buttonListener);
        previous.addActionListener(buttonListener);
        next.addActionListener(buttonListener);
        last.addActionListener(buttonListener);


        JPanel head = new JPanel();
        head.setLayout(new BorderLayout());
        head.add(BorderLayout.CENTER, logo);
        JPanel up = new JPanel();
        up.setLayout(new GridLayout(6, 2));
        up.add(itemNum);
        up.add(itemNumValue);
        up.add(unit);
        up.add(unitValue);
        up.add(name);
        up.add(nameValue);
        up.add(price);
        up.add(priceValue);
        up.add(restockingFee);
        up.add(rfValue);
        up.add(invent);
        up.add(inventValue);
        display();
        JPanel middle = new JPanel();
        middle.setLayout(new FlowLayout());
        middle.add(first);
        middle.add(previous);
        middle.add(next);
        middle.add(last);
        JPanel down = new JPanel();
        down.setLayout(new BorderLayout());
        down.add(BorderLayout.CENTER, totalValue);

        JPanel all = new JPanel();
        all.setLayout(new BoxLayout(all, BoxLayout.Y_AXIS));
        all.add(up);
        all.add(down);
        all.add(middle);

        Container cp = getContentPane();
        cp.add(BorderLayout.NORTH, head);
        cp.add(BorderLayout.CENTER, all);
    }

    public static void main(String[] args) {
        JApplet applet = new ProductTest4();
        JFrame frame = new JFrame("Inventory Part5");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setResizable(false);
        frame.getContentPane().add(applet);
        frame.setSize(520, 350);
        applet.init();
        frame.setVisible(true);
    }
}